function [output] = Fmusiclef_web(command, model_s, lastfmmodel_s, fileID, text)
% This code is provided as the REFERENCE code to perform multi-label
% classification for the Media-Eval Music Tagging brave new task
%
% USAGE:
% =======
% - See REF_training_class for usage
%
% This code was partly written by Markus Schedl (markus.schedl@jku.at) in 2012 for the Media-Eval Music Tagging brave new task


switch command
    
    case 'training'

        nb_file = length(model_s.filelist_c);
        for l=1:nb_file
            fprintf(1, '%d/%d\n', l, nb_file);
            % find tfidf vector for current track
            lastfm_model(l).track = model_s.filelist_c{l};
            test = {text.track.id};
            idx = find([test{1,:}] == str2num(lastfm_model(l).track));
            lastfm_model(l).weights = text.track(idx).lastfm_tag_counts_normalized;
        end        
        output = lastfm_model;
        
        
    case 'classification'

        % target_track_s = fileID;
        test = {text.track.id};
        idx = find([test{1,:}] == str2num(fileID));
        
        weight_target = text.track(idx).lastfm_tag_counts_normalized;
        
        sim_v      = zeros(length(lastfmmodel_s), 1);
        for l=1:length(lastfmmodel_s)
            sim_v(l) = cossim(weight_target, lastfmmodel_s(l).weights);
        end
        [max_value, max_pos]    = max(sim_v);
         
        % === return tag corresponding to the closest item
        output = model_s.taglist_c(find(model_s.matrix_m(max_pos,:)));
        
%        disp(['last.fm -> seed: ' num2str(fileID) 'closest: ' model_s.filelist_c(max_pos)])
end



% ========================
function [similarity] = cossim(M0, M1)

similarity = pdist([M0', M1']', 'cosine');

